import com.imptt.proptt.adminweb.plugins.V2.*;
import java.sql.*;

public class AdminWebPluginSample implements IAdminWebPlugin2
{
	ICallback2 cbObject = null;
	public int getInterfaceVersion()
	{
		System.out.println("AdminWebPluginSample::getInterfaceVersion");
		return INTERFACE_VERSION;
	}
	
	public int getType()
	{
		System.out.println("AdminWebPluginSample::getType");
		return TYPE_GENERAL_PLUGIN;
	}
	
	public void setCallback(ICallback2 cbObject)
	{
		System.out.println("AdminWebPluginSample::setCallback cbObject="+cbObject);
		this.cbObject = cbObject;
	}
	
	public boolean initialize(String arg)
	{
		System.out.println("AdminWebPluginSample::initialize arg="+arg);
		Connection conn = cbObject.getDBConnection();
		if(conn != null)
		{
			int dbSchemaVersion = 0;
			Statement stmt = null;
			try 
			{
				stmt = conn.createStatement();
				String sqlStr = "SELECT TextValue FROM TB_Setup WHERE TextKey='db.schema.version'";
				ResultSet rs = stmt.executeQuery(sqlStr);
				if(rs.next())
				{
					dbSchemaVersion = rs.getInt(1);
				}
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
			}
			if ( stmt != null ) try { stmt.close(); }catch (Exception e){}
			System.out.println("AdminWebPluginSample::initialize dbSchemaVersion="+dbSchemaVersion);
		}
		if(cbObject!=null) cbObject.OnInitialized();
		return true;
	}
	

	//events
	
	public String autheticate(PTTUser2 user, String hashedPassword, boolean passwordVerified, String device, String os, String app, String peerIp, String token)
	{
		System.out.println("AdminWebPluginSample::autheticate userId="+user.strID+", plainPassword="+user.strPlainPassword+", passwordVerified="+passwordVerified);
		if(passwordVerified==false) return "failure";
		if(app.startsWith("ProGate/")) return "success"; //ProGate don't support 2 phase authentication
		if(token==null || token.isEmpty()) return "required";
		if(token.equals("1234")) return "5678";
		if(token.equals("5678")) return "success";
		if(token.equals("retry")) {
			//have to send new token to user
		}
		return "required";
	}

	public boolean allocVideoServer(PTTUser2 user, String hashedPassword, boolean passwordVerified, String peerIp, String token)
	{
		System.out.println("AdminWebPluginSample::allocVideoServer userId="+user.strID+", plainPassword="+user.strPlainPassword+", passwordVerified="+passwordVerified+", token="+token);
		//return passwordVerified;
		if(token!=null && token.equals("5678")) return true;
		return false;
	}

	public void OnError(int errCode, String jsonParams)
	{
		System.out.println("AdminWebPluginSample::OnError errCode="+errCode+", jsonParams="+jsonParams);
	}
	
	public void OnExtenedEvent(String cmdName, String jsonParams)
	{
		System.out.println("AdminWebPluginSample::OnExtenedEvent cmdName="+cmdName+", jsonParams="+jsonParams);
	}
	
}
